#!/usr/bin/perl

######################################
#                                    #
# mailing.cgi v1.0 March 2002        #
#                                    #
# Written by Scott David Gray        #
#                                    #
# Contact:                           #
#  Scott David Gray                  #
#                                    #
# email: sgray@sudval.org            #
#                                    #
# URL: http://unseelie.org           #
#                                    #
# (c) 2001, 2002 by Scott David Gray #
#                                    #
#################################################################
#                                                               #
# This program is free software; you can redistribute it and/or #
# modify it under the terms of the GNU General Public License   #
# as published by the Free Software Foundation; either version  #
# 2 of the License, or (at your option) any later version.      #
#                                                               #
# This program is distributed in the hope that it will be       #
# useful, but WITHOUT ANY WARRANTY; without even the implied    #
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR       #
# PURPOSE.  See the GNU General Public License for more         #
# details.                                                      #
#                                                               #
# You should have received a copy of the GNU General Public     #
# License along with this program; if not, write to the Free    #
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, #
# USA.                                                          #
#                                                               #
#                                                               #
#################################################################

#
# User variables -- set these variables according to your system
#

 $person_mail_appears_to_be_from ="nobody\@localhost" ;

 $default_bcc_recipient_address ="sgray\@localhost" ;

 $default_sendmail_command="|/usr/lib/sendmail -oi -t -odq" ;

#
# Gather raw data
#

$time_of_program_activation = localtime(time) ;

use CGI qw(:standard);

 $location_of_text_form = param("location_of_text_form") ;

if (-e $location_of_text_form) {

 open (MAILFORM, "<$location_of_text_form") ;

  $inside_the_mailform=@keyword_in_mailform=<MAILFORM> ;

  for ( $n = 0 ; $n < $inside_the_mailform ; $n++ ) {

   $thisline_in_mailform = "$keyword_in_mailform[$n]" ;

   while ($thisline_in_mailform =~ /\[/) {

    $referenced_variable_name = $thisline_in_mailform ;

    $referenced_variable_name =~ s/^.+\[// ;

    $referenced_variable_name =~ s/\].+$// ;

    $referenced_variable_name =~ s/\]// ;

    $referenced_variable_name =~ s/\n// ;

    $working_variable = param($referenced_variable_name) ;

    $thisline_in_mailform =~ s/\[$referenced_variable_name\]/$working_variable/ ;

   }

   $internal_version_of_body[$n] = $thisline_in_mailform ;

  }

 close (MAILFORM) ;

#
# Send email
#

 open (SENDMAIL, $default_sendmail_command) ;

  print SENDMAIL "Date: $time_of_program_activation\n" ;

  print SENDMAIL "From: $person_mail_appears_to_be_from\n" ;

  print SENDMAIL "Bcc: $default_bcc_recipient_address\n" ;

  for ( $n = 0 ; $n < $inside_the_mailform ; $n++ ) {

    print SENDMAIL "$internal_version_of_body[$n]" ;

  }

 close (SENDMAIL) ;

#
# Show results page
#

 print ("Content-type: text/html\nPragma: no-cache\n\n") ;

  print ("<HTML>\n\n") ;

  print ("<CENTER>\n\n") ;

  print ("The following email was sent:\n\n") ;

  print ("</CENTER>\n\n") ;

  print ("<PRE>\n") ;

  print ("Date: $time_of_program_activation\n") ;

  print ("From: $person_mail_appears_to_be_from\n") ;

  print ("Bcc: $default_bcc_recipient_address\n") ;

  for ( $n = 0 ; $n < $inside_the_mailform ; $n++ ) {

    print ("$internal_version_of_body[$n]") ;

  }

  print ("</PRE>\n\n") ;

  print ("</HTML>\n\n") ;

} else {

 print ("Content-type: text/html\nPragma: no-cache\n\n") ;

 print ("<HTML>\n\n") ;

 print ("<BR>\n") ;

 print ("No email was sent, because the configuration file\n") ;

 print ("<BR>\n") ;

 print ("could not be found.\n") ;

 print ("<BR>\n") ;

 print ("\n") ;

 print ("<BR>\n") ;

 print ("</HTML>\n\n") ;

}
